#include "ft_containers_tester.hpp"

void	displayBanner(void) {
	std::cout << std::endl;
	std::cout << "'########:'########:::::::::::'######:::'#######::'##::: ##:'########::::'###::::'####:'##::: ##:'########:'########:::::'########:'########::'######::'########:'########:'########::" << std::endl;
	std::cout << " ##.....::... ##..:::::::::::'##... ##:'##.... ##: ###:: ##:... ##..::::'## ##:::. ##:: ###:: ##: ##.....:: ##.... ##::::... ##..:: ##.....::'##... ##:... ##..:: ##.....:: ##.... ##:" << std::endl;
	std::cout << " ##:::::::::: ##::::::::::::: ##:::..:: ##:::: ##: ####: ##:::: ##:::::'##:. ##::: ##:: ####: ##: ##::::::: ##:::: ##::::::: ##:::: ##::::::: ##:::..::::: ##:::: ##::::::: ##:::: ##:" << std::endl;
	std::cout << " ######:::::: ##::::::::::::: ##::::::: ##:::: ##: ## ## ##:::: ##::::'##:::. ##:: ##:: ## ## ##: ######::: ########:::::::: ##:::: ######:::. ######::::: ##:::: ######::: ########::" << std::endl;
	std::cout << " ##...::::::: ##::::::::::::: ##::::::: ##:::: ##: ##. ####:::: ##:::: #########:: ##:: ##. ####: ##...:::: ##.. ##::::::::: ##:::: ##...:::::..... ##:::: ##:::: ##...:::: ##.. ##:::" << std::endl;
	std::cout << " ##:::::::::: ##::::::::::::: ##::: ##: ##:::: ##: ##:. ###:::: ##:::: ##.... ##:: ##:: ##:. ###: ##::::::: ##::. ##:::::::: ##:::: ##:::::::'##::: ##:::: ##:::: ##::::::: ##::. ##::" << std::endl;
	std::cout << " ##:::::::::: ##::::'#######:. ######::. #######:: ##::. ##:::: ##:::: ##:::: ##:'####: ##::. ##: ########: ##:::. ##::::::: ##:::: ########:. ######::::: ##:::: ########: ##:::. ##:" << std::endl;
	std::cout << "..:::::::::::..:::::.......:::......::::.......:::..::::..:::::..:::::..:::::..::....::..::::..::........::..:::::..::::::::..:::::........:::......::::::..:::::........::..:::::..::" << std::endl;
	std::cout << std::endl;
}

int	main(int ac, char **av) {
	if (ac < 3) {
		displayBanner();
		Register list;

		if ((ac == 1) || (strcmp(av[1], "vector") == 0))
			addVectorFunctions(&list);
		if ((ac == 1) || (strcmp(av[1], "stack") == 0))
			addStackFunctions(&list);
		if ((ac == 1) || (strcmp(av[1], "pair") == 0))
			addPairFunctions(&list);
		if ((ac == 1) || (strcmp(av[1], "map") == 0))
			addMapFunctions(&list);
		if ((ac == 1) || (strcmp(av[1], "set") == 0))
			addSetFunctions(&list);
		list.runAllTests();
	} else {
		std::cout << "Error: Too many arguments" << std::endl;
	}
	return (0);
}
